#include <pic16f84a.h>

/* ejerext5.c
 * Jose Luis Dobler Trueba
 * Entradas: clave de 3 bits (n = 0...7) en los microswitches.
 * Salidas: LED B(n) encendido, los demas apagados.  Fin del programa.
 * Para compilar: sdcc -mpic14 -p16f84a ejerext5.c */

#define TIEMPO 2000

unsigned int at (0x2007) __CONFIG = _WDT_OFF & _CP_OFF & _XT_OSC;

char check(void) {
	unsigned int i;
	for(i = 0; i < TIEMPO; i++);
	return PORTA;
}

void main(void) {
	char n;

	PORTA = 0;
	PORTB = 0;
	TRISA = 0xfe;
	TRISB = 0;

	while(1) {
		n = (check() & 0x0e) >> 1;
		PORTB = 0x00;
		switch(n) {
			case 0x00:
				PORTB = 0x01;
				check();
				break;
			case 0x01:
				PORTB = 0x02;
				check();
				break;
			case 0x02:
				PORTB = 0x04;
				check();
				break;
			case 0x03:
				PORTB = 0x08;
				check();
				break;
			case 0x04:
				PORTB = 0x10;
				check();
				break;
			case 0x05:
				PORTB = 0x20;
				check();
				break;
			case 0x06:
				PORTB = 0x40;
				check();
				break;
			case 0x07:
				PORTB = 0x80;
				check();
				break;
			default:
				PORTB = 0x00;
				check();
				break;
		}
	}
}
