#include <pic16f84a.h>

/* ejerext8.c
 * Jose Luis Dobler Trueba
 * Entradas: clave de 3 bits (n = 0...7) en los microswitches.  Salidas:
 * empezando con el LED B0, encendido, los demas apagados, hacer corrimientos
 * hacia la izquierda.  Al llegar al LED B(n), encendido, activar el relevador.
 * Continuar con los corrimientos (al llegar a B7, seguir con B0).  A la
 * siguiente vuelta, desactivarlo y asi sucesivamente.  Retraso de 200 ms.
 * Para compilar: sdcc -mpic14 -p16f84a ejerext8.c */

#define TIEMPO 200

unsigned int at (0x2007) __CONFIG = _WDT_OFF & _CP_OFF & _XT_OSC;

char check(char n) {
	unsigned int i;
	for(i = 0; i < (TIEMPO * (8 - n)); i++);
	return PORTA;
}

void main(void) {
	char n, i, led;

	PORTA = 0;
	PORTB = 0;
	TRISA = 0xfe;
	TRISB = 0;

	while(1) {
		n = (check(8) & 0x0e) >> 1;
		led = 0;
		PORTB = 0x01;
		if(n == led && !(PORTA & 0x01))
			PORTA++;
		else if(n == led && (PORTA & 0x01))
			PORTA--;
		check(1);
		for(i = 0; i < 7; i++) {
			led++;
			PORTB = PORTB << 1;
			if(n == led && !(PORTA & 0x01))
				PORTA += 1;
			else if(n == led && (PORTA & 0x01))
				PORTA -= 1;
			check(1);
		}
	}
}
