#include <pic16f84a.h>

/* ejerext9.c
 * Jose Luis Dobler Trueba
 * Generar retrasos variables, aproximados de 1 a 4 segundos dependiendo del
 * microswitch SW1..SW4, activo.  Al final del retraso, activar el relevador.
 * Flashear el led B0 cada segundo.
 * Para compilar: sdcc -mpic14 -p16f84a ejerext9.c */

#define SEGUNDO 65000
#define FLASH 1000

unsigned int at (0x2007) __CONFIG = _WDT_OFF & _CP_OFF & _XT_OSC;

char check(unsigned int n) {
	unsigned int i;
	for(i = 0; i < n; i++);
	return PORTA;
}

void main(void) {
	char n, i, segs;

	PORTA = 0;
	PORTB = 0;
	TRISA = 0xfe;
	TRISB = 0;

	while(1) {
		segs = 4;
		n = (check(0) & 0x1e) >> 1;
		if(PORTA & 0x01)
			PORTA--;
		switch(n) {
			case 0x01:
				segs--;
			case 0x02:
				segs--;
			case 0x04:
				segs--;
			case 0x08:
				for(i = 0; i < segs; i++) {
					PORTB = 0x00;
					check(SEGUNDO -  FLASH);
					PORTB = 0x01;
					check(FLASH);
					PORTB = 0x00;
				}
				if(!(PORTA & 0x01))
					PORTA++;
				check(FLASH);
				break;
			default:
				break;
		}
	}
}
